﻿using FarPoint.Win.Spread;
using GrapeCity.Spreadsheet;
using GrapeCity.Spreadsheet.Drawing;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CarInsuranceClaim
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            fpSpread1.Features.EnhancedShapeEngine = true;
            fpSpread1.Features.RichClipboard = true;
            using (MemoryStream s = new MemoryStream(ExcelTemplate.car_repair_excel))
            {
                fpSpread1.OpenExcel(s, FarPoint.Excel.ExcelOpenFlags.DocumentCaching);
            }
            fpSpread1.ActiveSheet.RowCount = 43;
            IWorkbook workbook = fpSpread1.AsWorkbook();
            for (int n = 0; n < workbook.ActiveSheet.Shapes.Count; n++)
            {
                IShape shape = workbook.ActiveSheet.Shapes[n];
                shape.CanMove = Moving.None;
                shape.CanRotate = false;
                shape.CanSize = Sizing.None;
                if (shape.Name == "Picture 2")
                    continue;
                shape.Action += Shape_Action;
            }
            BindProperties();
        }

        private void BindProperties()
        {
            IWorkbook workbook = fpSpread1.AsWorkbook();
            IShapes shapes = workbook.Worksheets[0].Shapes;
            // bind shape properties to cells
            shapes["Front"].Bindings.Add("Left", "Sheet2!B2");
            shapes["Front"].Bindings.Add("Top", "Sheet2!C2");
            shapes["Front"].Bindings.Add("Width", "Sheet2!D2");
            shapes["Front"].Bindings.Add("Height", "Sheet2!E2");
            shapes["Front"].Bindings.Add("Line", "Sheet2!F2");
            shapes["Hood"].Bindings.Add("Left", "Sheet2!B3");
            shapes["Hood"].Bindings.Add("Top", "Sheet2!C3");
            shapes["Hood"].Bindings.Add("Width", "Sheet2!D3");
            shapes["Hood"].Bindings.Add("Height", "Sheet2!E3");
            shapes["Hood"].Bindings.Add("Line", "Sheet2!F3");
            shapes["FrontWindshield"].Bindings.Add("Left", "Sheet2!B4");
            shapes["FrontWindshield"].Bindings.Add("Top", "Sheet2!C4");
            shapes["FrontWindshield"].Bindings.Add("Width", "Sheet2!D4");
            shapes["FrontWindshield"].Bindings.Add("Height", "Sheet2!E4");
            shapes["FrontWindshield"].Bindings.Add("Line", "Sheet2!F4");
            shapes["Roof"].Bindings.Add("Left", "Sheet2!B5");
            shapes["Roof"].Bindings.Add("Top", "Sheet2!C5");
            shapes["Roof"].Bindings.Add("Width", "Sheet2!D5");
            shapes["Roof"].Bindings.Add("Height", "Sheet2!E5");
            shapes["Roof"].Bindings.Add("Line", "Sheet2!F5");
            shapes["RearTop"].Bindings.Add("Left", "Sheet2!B6");
            shapes["RearTop"].Bindings.Add("Top", "Sheet2!C6");
            shapes["RearTop"].Bindings.Add("Width", "Sheet2!D6");
            shapes["RearTop"].Bindings.Add("Height", "Sheet2!E6");
            shapes["RearTop"].Bindings.Add("Line", "Sheet2!F6");
            shapes["Rear"].Bindings.Add("Left", "Sheet2!B7");
            shapes["Rear"].Bindings.Add("Top", "Sheet2!C7");
            shapes["Rear"].Bindings.Add("Width", "Sheet2!D7");
            shapes["Rear"].Bindings.Add("Height", "Sheet2!E7");
            shapes["Rear"].Bindings.Add("Line", "Sheet2!F7");
            shapes["LeftFront"].Bindings.Add("Left", "Sheet2!B8");
            shapes["LeftFront"].Bindings.Add("Top", "Sheet2!C8");
            shapes["LeftFront"].Bindings.Add("Width", "Sheet2!D8");
            shapes["LeftFront"].Bindings.Add("Height", "Sheet2!E8");
            shapes["LeftFront"].Bindings.Add("Line", "Sheet2!F8");
            shapes["LeftFrontDoor"].Bindings.Add("Left", "Sheet2!B9");
            shapes["LeftFrontDoor"].Bindings.Add("Top", "Sheet2!C9");
            shapes["LeftFrontDoor"].Bindings.Add("Width", "Sheet2!D9");
            shapes["LeftFrontDoor"].Bindings.Add("Height", "Sheet2!E9");
            shapes["LeftFrontDoor"].Bindings.Add("Line", "Sheet2!F9");
            shapes["LeftBackDoor"].Bindings.Add("Left", "Sheet2!B10");
            shapes["LeftBackDoor"].Bindings.Add("Top", "Sheet2!C10");
            shapes["LeftBackDoor"].Bindings.Add("Width", "Sheet2!D10");
            shapes["LeftBackDoor"].Bindings.Add("Height", "Sheet2!E10");
            shapes["LeftBackDoor"].Bindings.Add("Line", "Sheet2!F10");
            shapes["LeftBack"].Bindings.Add("Left", "Sheet2!B11");
            shapes["LeftBack"].Bindings.Add("Top", "Sheet2!C11");
            shapes["LeftBack"].Bindings.Add("Width", "Sheet2!D11");
            shapes["LeftBack"].Bindings.Add("Height", "Sheet2!E11");
            shapes["LeftBack"].Bindings.Add("Line", "Sheet2!F11");
            shapes["RightFront"].Bindings.Add("Left", "Sheet2!B12");
            shapes["RightFront"].Bindings.Add("Top", "Sheet2!C12");
            shapes["RightFront"].Bindings.Add("Width", "Sheet2!D12");
            shapes["RightFront"].Bindings.Add("Height", "Sheet2!E12");
            shapes["RightFront"].Bindings.Add("Line", "Sheet2!F12");
            shapes["RightFrontDoor"].Bindings.Add("Left", "Sheet2!B13");
            shapes["RightFrontDoor"].Bindings.Add("Top", "Sheet2!C13");
            shapes["RightFrontDoor"].Bindings.Add("Width", "Sheet2!D13");
            shapes["RightFrontDoor"].Bindings.Add("Height", "Sheet2!E13");
            shapes["RightFrontDoor"].Bindings.Add("Line", "Sheet2!F13");
            shapes["RightBackDoor"].Bindings.Add("Left", "Sheet2!B14");
            shapes["RightBackDoor"].Bindings.Add("Top", "Sheet2!C14");
            shapes["RightBackDoor"].Bindings.Add("Width", "Sheet2!D14");
            shapes["RightBackDoor"].Bindings.Add("Height", "Sheet2!E14");
            shapes["RightBackDoor"].Bindings.Add("Line", "Sheet2!F14");
            shapes["RightBack"].Bindings.Add("Left", "Sheet2!B15");
            shapes["RightBack"].Bindings.Add("Top", "Sheet2!C15");
            shapes["RightBack"].Bindings.Add("Width", "Sheet2!D15");
            shapes["RightBack"].Bindings.Add("Height", "Sheet2!E15");
            shapes["RightBack"].Bindings.Add("Line", "Sheet2!F15");
        }

        private void Shape_Action(object sender, ShapeEventArgs e)
        {
            IWorkbook workbook = fpSpread1.AsWorkbook();
            IWorksheet worksheet = workbook.ActiveSheet;
            IShapes shapes = worksheet.Shapes;
            if (e.Shape != null)
            {
                string name = e.Shape.Name;
                if (e.Shape.Fill.Transparency == 0.99)
                {
                    e.Shape.Fill.Transparency = 0.5;
                    if (name == "Front" || name == "Rear")
                        shapes["BumperDamage"].Fill.Transparency = 0.5;
                    if (name == "Roof")
                        shapes["RoofDamage"].Fill.Transparency = 0.5;
                    if (name == "RoofDamage")
                        shapes["Roof"].Fill.Transparency = 0.5;
                    if (name == "HighSeverity" || name == "MediumSeverity" || name == "LowSeverity")
                    {
                        shapes["HighSeverity"].Fill.Transparency = 0.99;
                        shapes["MediumSeverity"].Fill.Transparency = 0.99;
                        shapes["LowSeverity"].Fill.Transparency = 0.99;
                        shapes[name].Fill.Transparency = 0.5;
                    }
                }
                else
                {
                    e.Shape.Fill.Transparency = 0.99;
                    if (name == "Front" && shapes["Rear"].Fill.Transparency == 0.99)
                        shapes["BumperDamage"].Fill.Transparency = 0.99;
                    if (name == "Rear" && shapes["Front"].Fill.Transparency == 0.99)
                        shapes["BumperDamage"].Fill.Transparency = 0.99;
                    if (name == "Roof")
                        shapes["RoofDamage"].Fill.Transparency = 0.99;
                    if( name == "RoofDamage")
                        shapes["Roof"].Fill.Transparency = 0.99;
                }
            }
        }

        private void SaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog d = new SaveFileDialog();
            d.Filter = "Excel Macro-enabled Workbook (*.XLSM)|*.XLSM";
            d.FilterIndex = 0;
            d.Title = "Save File";
            if (d.ShowDialog() == DialogResult.OK)
            {
                fpSpread1.SaveExcel(d.FileName, FarPoint.Excel.ExcelSaveFlags.DocumentCaching | FarPoint.Excel.ExcelSaveFlags.UseOOXMLFormat);
            }
        }

        private void ExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
